uses
  Classes, Math;

const
  BS = 100;

var
  xmin, xmax, ymin, ymax, N: Integer;
  x, y: array of Integer;
  passwords: TStringList;
  v: array [-400..1100, -400..1100] of Boolean;

function GetDigit(x, y: Integer): Integer;
begin
  if InRange(x, 0, 3 * BS - 1) and InRange(y, 0, 3 * BS - 1) then
    Result := (2 - y div BS) * 3 + (x div BS) + 1
  else
    Result := 0;
end;

procedure GetPassword(dx, dy: Integer);
var
  i, d: Integer;
  pwd: String;
begin
  if v[dx, dy] then
    Exit;
  v[dx, dy] := true;
  SetLength(pwd, N);
  for i := 0 to N - 1 do begin
    d := GetDigit(x[i] - dx, y[i] - dy);
    if d = 0 then Exit;
    pwd[i + 1] := Chr(Ord('0') + d);
  end;
  passwords.Add(pwd);
end;

var
  f: TextFile;
  i, d: Integer;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N);
  SetLength(x, N); SetLength(y, N);
  for i := 0 to N - 1 do begin
    Read(f, x[i], y[i]);
    xmin := Min(xmin, x[i]); xmax := Max(xmax, x[i]);
    ymin := Min(ymin, x[i]); ymax := Max(ymax, y[i]);
  end;
  CloseFile(f);
  passwords := TStringList.Create;
  passwords.Capacity := N * 3 * 3 * 4;
  passwords.Sorted := false;
  for d := 0 to 299 do
      for i := 0 to N - 1 do begin
        GetPassword(x[i] - d, y[i]);
        GetPassword(x[i] - d, y[i] - BS);
        GetPassword(x[i] - d, y[i] - BS + 1);
        GetPassword(x[i] - d, y[i] - 2 * BS);
        GetPassword(x[i] - d, y[i] - 2 * BS + 1);
        GetPassword(x[i] - d, y[i] - 3 * BS);
        GetPassword(x[i], y[i] - d);
        GetPassword(x[i] - BS, y[i] - d);
        GetPassword(x[i] - BS + 1, y[i] - d);
        GetPassword(x[i] - 2 * BS, y[i] - d);
        GetPassword(x[i] - 2 * BS + 1, y[i] - d);
        GetPassword(x[i] - 3 * BS, y[i] - d);
      end;
  passwords.Duplicates := dupIgnore;
  passwords.Sorted := true;
  AssignFile(f, 'output.txt'); Rewrite(f);
  for i := 0 to passwords.Count - 1 do
    if (i = 0) or (passwords[i] <> passwords[i - 1]) then
      Writeln(f, passwords[i]);
  if passwords.Count = 0 then
    Writeln(f, 'NONE');
  CloseFile(f);
end.
