// ACM 2006
// Problem B. Better security
// Sergio A. Fjodorov

{$apptype console}

uses
  Classes;

const
  LABELS: array[0..2, 0..2] of char = (
    ('7', '8', '9'),
    ('4', '5', '6'),
    ('1', '2', '3')
  );
  WIDTH = 100;

var
  n: integer;
  x, y: array[1..100] of integer;
  i, j, k: integer;
  list: TStringList;
  s: string;

  function Between(X, A, B: integer): boolean;
  begin
    Result := (X >= A) and (X <= B);
  end;

  procedure TryPassword(WX, WY: integer);
  var
    i: integer;
    s: string;
    dx, dy: integer;
  begin
    s := '';

    for i := 1 to n do begin
      dx := (x[i] - WX);
      dy := (y[i] - WY);
      if
        not Between(dx, 0, 3 * WIDTH - 1) or
        not Between(dy, 0, 3 * WIDTH - 1)
      then
        exit;

      s := s + LABELS[dy div WIDTH, dx div WIDTH];
    end;

    list.Add(s);
  end;

begin
  Assign(input, 'input.txt');
  Reset(input);
  Assign(output, 'output.txt');
  Rewrite(output);

  list := TStringList.Create;
  try
    Read(n);
    for i := 1 to n do 
      Read(x[i], y[i]);

    for i := 0 to 2 do
      for j := 0 to 2 do
        for k := 1 to n do begin
            TryPassword(
              x[k] - i * WIDTH,
              y[k] - j * WIDTH);
            TryPassword(
              x[k] - i * WIDTH - WIDTH + 1,
              y[k] - j * WIDTH);
            TryPassword(
              x[k] - i * WIDTH,
              y[k] - j * WIDTH - WIDTH + 1);
            TryPassword(
              x[k] - i * WIDTH - WIDTH + 1,
              y[k] - j * WIDTH - WIDTH + 1);
        end;

    list.Sort;

    i := 0;
    while i < list.Count do begin
      s := list[i];
      WriteLn(s);
      while (i < list.Count) and (list[i] = s) do Inc(i);
    end;

    if list.Count = 0 then
      WriteLn('NONE');
  finally
    list.Free;
  end;

  Close(input);
  Close(output);
end.
